<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >
<head>
<link rel="stylesheet" type="text/css" href="style.css" />
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<meta name="theme-color" content="#0099ff"/>
<meta http-equiv="content-language" content="en" />
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<meta name="description" content="Overview of verifiers from SV-COMP 2020, for the use in component-based CEGAR (cCEGAR)" />
<meta name="keywords" content="Software Verification Software Engineering SV-COMP CEGAR" />
<title>Overview of verifiers from SV-COMP 2020</title>
</head>
<body>
<h1 id="overview-of-verifiers-from-sv-comp-2020">Overview of verifiers from SV-COMP 2020</h1>
<p>We are searching for verifiers that:</p>
<ol type="1">
<li>Can correctly solve tasks that CPAchecker cannot solve (1.1) and vice versa (1.2)</li>
<li>Have a “high quality” in their correctness witnesses. This means, that the invariants generated are
<ol type="1">
<li>valid C expressions without intermediate variables introduced by the verifiers pre-processing, and</li>
<li>are in fact helpfull proving the program correct (not trivial, like ‘true’ or <code>i &lt;= MAXINT</code> for <code>int i</code>)</li>
</ol></li>
</ol>
<table class="booktabs">
<thead>
<tr class="header">
<th>Tool</th>
<th>(1.1)</th>
<th>(1.2)</th>
<th>(2.1)</th>
<th>(2.2)</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><del>2ls</del></td>
<td>71</td>
<td>2474</td>
<td>Yes</td>
<td>No</td>
</tr>
<tr class="even">
<td><del>brick</del></td>
<td>39</td>
<td>3699</td>
<td>Yes</td>
<td>No</td>
</tr>
<tr class="odd">
<td>cbmc</td>
<td>150</td>
<td>2659</td>
<td>No</td>
<td>Yes</td>
</tr>
<tr class="even">
<td>cpa-seq</td>
<td>0</td>
<td>0</td>
<td>Yes</td>
<td>Yes</td>
</tr>
<tr class="odd">
<td><del>divine</del></td>
<td>67</td>
<td>3161</td>
<td>Yes</td>
<td>No</td>
</tr>
<tr class="even">
<td><del>esbmc</del></td>
<td>327</td>
<td>796</td>
<td>Yes</td>
<td>No</td>
</tr>
<tr class="odd">
<td>gacal</td>
<td>30</td>
<td>4040</td>
<td>Yes^2</td>
<td>Yes</td>
</tr>
<tr class="even">
<td><del>map2check</del></td>
<td>259</td>
<td>3673</td>
<td>Yes</td>
<td>No</td>
</tr>
<tr class="odd">
<td><del>Pinaka</del></td>
<td>174</td>
<td>1550</td>
<td>No</td>
<td>No</td>
</tr>
<tr class="even">
<td><del>PredatorHP</del></td>
<td>28</td>
<td>2</td>
<td>No</td>
<td>No</td>
</tr>
<tr class="odd">
<td><del>Symbiotic</del></td>
<td>204</td>
<td>1159</td>
<td>No</td>
<td>No</td>
</tr>
<tr class="even">
<td>UAutomizer</td>
<td>216</td>
<td>894</td>
<td>Yes^1</td>
<td>Yes</td>
</tr>
<tr class="odd">
<td>UKojak</td>
<td>38</td>
<td>1938</td>
<td>Yes^1</td>
<td>Yes</td>
</tr>
<tr class="even">
<td>UTaipan</td>
<td>69</td>
<td>1291</td>
<td>Yes^1</td>
<td>Yes</td>
</tr>
<tr class="odd">
<td>VeriAbs</td>
<td>897</td>
<td>87</td>
<td>Yes</td>
<td>Sometimes</td>
</tr>
<tr class="even">
<td><del>VeriFuzz</del></td>
<td>214</td>
<td>1661</td>
<td>No</td>
<td>No</td>
</tr>
</tbody>
</table>
<p>1: The Ultimate Framework produces witnesses that CPAchecker can not parse (several witness-automaton transitions for a single statement). This issue can be (and is) circumvented with a post-processing step that merges all witness-automaton transitions for a single statement into one transition.</p>
<p>2: CPAchecker can not parse any of the witnesses of GACAL.</p>
<p><strong>Comments to each verifier:</strong></p>
<ul>
<li><p>2LS: Trivial invariant witnesses, only describe some path, but no invariants.</p></li>
<li><p>BRICK: Trivial, single-state invariant witnesses.</p></li>
<li><p>CBMC: Encodes internal, termporary variables in invariant witnesses. Sometimes invariants are only variable assignments, sometimes more complicated invariants like relations between variables.</p></li>
<li><p>CPA-Seq: Good, of course ;-)</p></li>
<li><p>DIVINE: trivial, single-state witnesses</p></li>
<li><p>ESBMC: trivial, single-state witnesses</p></li>
<li><p>GACAL (only ReachSafety-Loops): Really nice invariants. Unfortunately CPAchecker seems to have issues with them.</p></li>
<li><p>Map2Check: trivial, single-state witnesses</p></li>
<li><p>Pinaka: Does only generate trivial invariant witnesses. Does not give any incorrect answer.</p></li>
<li><p>PredatorHP (only ReachSafty-Heap): Does only generate trivial invariant witnesses. Does not give any incorrect answer.</p></li>
<li><p>Symbiotic: Does only generate trivial invariant witnesses. Sometimes (16/4079) true is returned, although the property is violated.</p></li>
<li><p>UAutomizer: Generates correct C invariant witnesses with meaningful invariants.</p></li>
<li><p>UKojak: Does not give any incorrect answer.</p></li>
<li><p>UTaipan: Same as for UAutomizer</p></li>
<li><p>VeriAbs: Answers often correct, but many invariant witnesses are either trivial or do not contain relevant information. Not usable because of strict license.</p></li>
<li><p>VeriFuzz: Does not produce invariant witnesses.</p></li>
</ul>
</body>
</html>